/*
 * Project: dbRmTest
 * File: Form1.prg
 * Description:
 * Author: Hurricane
 * Date: 02/06/2025
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oBrw
   COMPONENT oCdxDataSource1
   COMPONENT oDbf
   COMPONENT oDBNavigator1
   COMPONENT oFolder1
   COMPONENT oFpPrincipal
   COMPONENT oFpFisica
   COMPONENT oFolderPage3
   COMPONENT oDbMaskEdit1
   COMPONENT oLabelBuddy1
   COMPONENT oRmTipo
   COMPONENT oLabelBuddy2
   COMPONENT oEdCnpjcpf
   COMPONENT oLabelBuddy3
   COMPONENT oDbMaskEdit3
   COMPONENT oLabelBuddy4
   COMPONENT oDbMaskEdit4
   COMPONENT oLabelBuddy5
   COMPONENT oDbMaskEdit5
   COMPONENT oLabelBuddy6
   COMPONENT oDBComboBox1
   COMPONENT oLabelBuddy7
   COMPONENT oDBComboBox2
   COMPONENT oLabelBuddy8
   COMPONENT oDBDateEdit1
   COMPONENT oLabelBuddy9

   METHOD CreateForm()
   METHOD FormInitialize( oSender )
   METHOD assignDataSet( oSender )
   METHOD RmTipoChange( oSender, nIndex, nOldIndex )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TForm1
   // 2025-02-06 11:15 Hurricane
   RddSetDefault('DBFCDX')
   SET EXCLUSIVE OFF
   SET DELETED ON
   SET EPOCH TO 1999
   SET CENTURY ON

   criarDbf()

   ::oRmTipo:aItemsBound:={'J', 'F'}

   ::oDbf:Open()

   ::oFpPrincipal:Select()
RETURN Nil

//------------------------------------------------------------------------------

METHOD RmTipoChange( oSender, nIndex, nOldIndex ) CLASS TForm1
   DEFAULT nIndex TO oSender:nIndex

   if nIndex = 1 // JURDICO
      ::oFpFisica:Disable()
   elseif nIndex = 2 // FSICA
      ::oFpFisica:Enable()
   endif
   ::oEdCnpjcpf:SetFocus()
RETURN Nil

//------------------------------------------------------------------------------

METHOD assignDataSet( oSender ) CLASS TForm1
   oSender:oDataSet:=::oDbf
RETURN Nil

//------------------------------------------------------------------------------
CLASS TDBRadioMenu FROM XDBRadioMenu
   DATA aItemsBound   INIT {}
ENDCLASS


FUNCTION criarDBF()
   LOCAL dNow
   LOCAL nPos
   LOCAL aEmpresas, aNomes
   LOCAL cRazNom

   if ! File('cliente.dbf')
      DBCreate( 'CLIENTE', { ;
         {'CODIGO', '+', 4, 0}, ;
         {'RAZNOM', 'C', 40, 0},;   // Razo Social / Nome
         {'TIPO', 'C', 1, 0},;      // J=Jurdica, F=Fsica
         {'CNPJCPF', 'C', 14, 0},;  // CNPJ / CPF
         {'IERG', 'C', 20, 0},;     // IE / RG
         {'NOMFAN', 'C', 40, 0},;   // Nome fantasia / Apelido
         {'ABERNSCM', 'D', 8, 0},;  // Data abertura / nascimento
         {'ESTCIVIL', 'C', 1, 0},;  // Pessoa fsica | Estado civil | S-Solteiro/a, C-Casado/a, D-Divorciado/a, V-Vivo/a, A-Amasiado
         {'GENERO', 'C', 1, 0},;    // Pessoa fsica | M-Masculino, F-Feminino, N-No informado
         {'ENDER', 'C', 50, 0},;    //
         {'NUMER', 'C', 10, 0},;    //
         {'BAIRRO', 'C', 30, 0},;   //
         {'CIDADE', 'C', 30, 0},;   //
         {'UF', 'C', 2, 0},;        //
         {'CEP', 'C', 8, 0} } )

      USE CLIENTE EXCLUSIVE

      aNomes   :={'+JOO', '+CARLOS', '+JOSE', 'ANA', '+PEDRO', 'APARECIDA', '+HURRICANE', 'MARIA', '+MARCELO', 'PAULA' }
      aEmpresas:={ 'MICROSOFT', 'CONSTRUTORA', 'AOUGUE', 'PADARIA', 'CONTABILIDADE', 'PIZZARIA' }
      dNow:=Date()

      for nPos:=1 TO 100
         DBAppend()
         if HB_RandomInt(2) = 2
            FIELD->TIPO    :='J'
            FIELD->RAZNOM  :=myRandom(aEmpresas) + ' ' + StrTran(myRandom(aNomes), '+' )
            FIELD->CNPJCPF :=StrZero( HB_RandomInt(1000), 4 ) + StrZero( HB_RandomInt(1000), 10 )
            FIELD->ABERNSCM:=dNow - (Int(HB_Random(1, 400)) * 300)
         else
            cRazNom:=myRandom(aNomes)
            FIELD->TIPO    :='F'
            FIELD->CNPJCPF :=StrZero( HB_RandomInt(999), 3 ) + StrZero( HB_RandomInt(999), 3 ) + StrZero( HB_RandomInt(999), 3 ) + StrZero( HB_RandomInt(99), 2 )
            FIELD->ABERNSCM:= dNow - (Int(HB_Random(18, 120)) * 300)
            FIELD->GENERO  :=IF( Left(cRazNom, 1) = '+', 'M', 'F' )
            FIELD->ESTCIVIL:=myRandom( 'SCDVA' )
            FIELD->RAZNOM  :=StrTran(cRazNom, '+')
         ENDIF
      next
      use
   endif
   return nil

FUNCTION myRandom( xValue ) // --> xRandom
   LOCAL xRandom
   LOCAL nRandom

   if EMPTY(xValue)

   elseif HB_IsChar(xValue)
      nRandom:=HB_RandomInt(Len(xValue))
      xRandom:=SubStr(xValue, nRandom, 1)
   elseif HB_IsArray(xValue)
      nRandom:=HB_RandomInt(Len(xValue))
      xRandom:=xValue[nRandom]
   endif
   RETURN xRandom

//------------------------------------------------------------------------------
